Index: src/work/marci/for_each_macros.h
===================================================================
--- src/work/marci/for_each_macros.h	(revision 636)
+++ src/work/marci/for_each_macros.h	(revision 725)
@@ -1,12 +1,12 @@
 // -*- c++ -*-
-#ifndef FOR_EACH_MACROS_H
-#define FOR_EACH_MACROS_H
+#ifndef HUGO_FOR_EACH_MACROS_H
+#define HUGO_FOR_EACH_MACROS_H
 
 // /// \ingroup gwrappers
 /// \file
-/// \brief Iteraton macros.
+/// \brief Iteration macros.
 ///
 /// This file contains several macros which make easier writting 
-/// for cycles in HUGO, using HUGO iterators.
+/// for cycles in HUGO using HUGO iterators.
 ///
 /// \author Marton Makai
@@ -14,47 +14,56 @@
 namespace hugo {
 
-/// The iteration with HUGO iterators i.e. for cycles can be 
-/// written very comfortable with this macro.
-/// \code
-/// Graph g;
-/// Graph::NodeIt n;
-/// FOR_EACH_GLOB(n, g) {
-/// ...
-/// }
-/// Graph::EdgeIt e;
-/// FOR_EACH_GLOB(e, g) {
-/// ...
-/// }
-/// In the above cycle, the iterator variable \c n and \c e are global ones. 
-/// \endcode
+  /// This macro provides a comfortable interface for iterating with HUGO 
+  /// iterators.
+  /// \code
+  /// Graph g;
+  /// ...
+  /// Graph::NodeIt n;
+  /// h_for_glob(n, g) {
+  /// ...
+  /// }
+  /// Graph::EdgeIt e;
+  /// h_for_glob(e, g) {
+  /// ...
+  /// }
+  /// \endcode
+  /// Note that the iterated variables \c n and \c e are global ones. 
+#define h_for_glob(e, g) for((g).first((e)); (g).valid((e)); (g).next((e)))
+
+/// \deprecated
 #define FOR_EACH_GLOB(e, g) for((g).first((e)); (g).valid((e)); (g).next((e)))
 
-/// The iteration with HUGO iterators i.e. for cycles can be 
-/// written very comfortable with this macro.
-/// \code
-/// Graph g;
-/// Graph::Node v;
-/// Graph::OutEdgeIt e;
-/// FOR_EACH_INC_GLOB(e, g, v) {
-/// ...
-/// }
-/// typedef BipartiteGraph<Graph> BGraph;
-/// BGraph h;
-/// BGraph::ClassNodeIt n;
-/// FOR_EACH_INC_GLOB(BGraph::ClassNodeIt, n, h, h.S_CLASS) {
-/// ...
-/// }
-/// In the above cycle, the iterator variable \c e and \c n are global ones. 
-/// \endcode
-#define FOR_EACH_INC_GLOB(e, g, v) for((g).first((e), (v)); (g).valid((e)); (g).next((e)))
+  /// This macro provides a comfortable interface for iterating with HUGO 
+  /// iterators.
+  /// \code
+  /// Graph g;
+  /// ...
+  /// Graph::Node v;
+  /// Graph::OutEdgeIt e;
+  /// h_for_inc_glob(e, g, v) {
+  /// ...
+  /// }
+  /// typedef BipartiteGraph<Graph> BGraph;
+  /// BGraph h;
+  /// ...
+  /// BGraph::ClassNodeIt n;
+  /// h_for_inc_glob(BGraph::ClassNodeIt, n, h, h.S_CLASS) {
+  /// ...
+  /// }
+  /// \endcode
+  /// Note that iterated variables \c e and \c n are global ones. 
+#define h_for_inc_glob(e, g, v) for((g).first((e), (v)); (g).valid((e)); (g).next((e)))
 
 /// \deprecated
-#define FOR_EACH_EDGE_GLOB(e, g) for((g).first((e)); (g).valid((e)); (g).next((e)))
+#define FOR_EACH_INC_GLOB(e, g, v) for((g).first((e), (v)); (g).valid((e)); (g).next((e)))
+  
 /// \deprecated
-#define FOR_EACH_NODE_GLOB(e, g) for((g).first((e)); (g).valid((e)); (g).next((e)))
+//#define FOR_EACH_EDGE_GLOB(e, g) for((g).first((e)); (g).valid((e)); (g).next((e)))
 /// \deprecated
-#define FOR_EACH_INEDGE_GLOB(e, g, v) for((g).first((e), (v)); (g).valid((e)); (g).next((e)))
+//#define FOR_EACH_NODE_GLOB(e, g) for((g).first((e)); (g).valid((e)); (g).next((e)))
 /// \deprecated
-#define FOR_EACH_OUTEDGE_GLOB(e, g, v) for((g).first((e), (v)); (g).valid((e)); (g).next((e)))
+//#define FOR_EACH_INEDGE_GLOB(e, g, v) for((g).first((e), (v)); (g).valid((e)); (g).next((e)))
+/// \deprecated
+//#define FOR_EACH_OUTEDGE_GLOB(e, g, v) for((g).first((e), (v)); (g).valid((e)); (g).next((e)))
 
 //   template<typename It, typename Graph> 
@@ -117,35 +126,44 @@
 //   }
 
-/// The iteration with HUGO iterators i.e. for cycles can be 
-/// written very comfortable with this macro.
-/// \code
-/// Graph g;
-/// FOR_EACH_LOC(Graph::NodeIt, n, g) {
-/// ...
-/// }
-/// FOR_EACH_LOC(Graph::EdgeIt, e, g) {
-/// ...
-/// }
-/// In the above cycle, the iterator variable \c n and \c e are local ones. 
-/// \endcode
+  /// This macro provides a comfortable interface for iterating with HUGO 
+  /// iterators.
+  /// \code
+  /// Graph g;
+  /// ...
+  /// h_for(Graph::NodeIt, n, g) {
+  /// ...
+  /// }
+  /// h_for(Graph::EdgeIt, e, g) {
+  /// ...
+  /// }
+  /// \endcode
+  /// Note that the iterated variables \c n and \c e are local ones. 
+#define h_for(Ittype, e, g) for(Ittype e=loopFirst(Ittype(), (g)); (g).valid(e); (g).next(e))
+  
+/// \deprecated
 #define FOR_EACH_LOC(Ittype, e, g) for(Ittype e=loopFirst(Ittype(), (g)); (g).valid(e); (g).next(e))
 
-/// The iteration with HUGO iterators i.e. for cycles can be 
-/// written very comfortable with this macro.
-/// \code
-/// Graph g;
-/// Graph::Node v;
-/// FOR_EACH_INC_LOC(Graph::OutEdgeIt, e, g, v) {
-/// ...
-/// }
-/// typedef BipartiteGraph<Graph> BGraph;
-/// BGraph h;
-/// FOR_EACH_INC_LOC(BGraph::ClassNodeIt, n, h, h.S_CLASS) {
-/// ...
-/// }
-/// In the above cycle, the iterator variable \c e and \c n are local ones. 
-/// \endcode
+  /// This macro provides a comfortable interface for iterating with HUGO 
+  /// iterators.
+  /// \code
+  /// Graph g;
+  /// ...
+  /// Graph::Node v;
+  /// h_for_inc(Graph::OutEdgeIt, e, g, v) {
+  /// ...
+  /// }
+  /// typedef BipartiteGraph<Graph> BGraph;
+  /// BGraph h;
+  /// ...
+  /// h_for_inc(BGraph::ClassNodeIt, n, h, h.S_CLASS) {
+  /// ...
+  /// }
+  /// \endcode
+  /// Note that the iterated variables \c e and \c n are local ones. 
+#define h_for_inc(Ittype, e, g, v) for(Ittype e=loopFirst(Ittype(), (g), (v)); (g).valid(e); (g).next(e))
+  
+/// \deprecated
 #define FOR_EACH_INC_LOC(Ittype, e, g, v) for(Ittype e=loopFirst(Ittype(), (g), (v)); (g).valid(e); (g).next(e))
-
+  
 // #define FOR_EACH_EDGE_LOC(e, g) ezt nem tom hogy kell for((g).first((e)); (g).valid((e)); (g).next((e)))
 // #define FOR_EACH_NODE_LOC(e, g) for((g).first((e)); (g).valid((e)); (g).next((e)))
@@ -153,6 +171,5 @@
 // #define FOR_EACH_OUTEDGE_LOC(e, g, v) for((g).first((e), (v)); (g).valid((e)); (g).next((e)))
 
-
 } //namespace hugo
 
-#endif //FOR_EACH_MACROS_H
+#endif //HUGO_FOR_EACH_MACROS_H